<?php

/* questions:
  - what is M? is it just a way of saying " I am on the R face " or is it really a mirror variable?
  - what is U and V (as in rotu, rotv)
 */
// post, get
$constants = new stdClass;
// constants
$constants->colors = array(
    'r' => 0xD00000, // red
    'o' => 0xEE8800, // orange
    'b' => 0x2040D0, // blue
    'g' => 0x11AA00, // green
    'w' => 0xFFFFFF, // white
    'y' => 0xFFFF00, // yellow
    'l' => 0xDDDDDD, // lightgray
    'd' => 0x555555, // gray
    'x' => 0x999999, // silver
    'k' => 0x111111, // darkgray
    'c' => 0x0099FF, // cyan
    'p' => 0xFF99CC, // pink
    'm' => 0xFF0099, // magenta
    'black' => 0x010101,
    'veryDarkGray' => 0x050505,
    'darkGray' => 0x090909
);
$constants->smoothing = 5;

class Page {

    function get($s, $defaultValue = '') {
        $value = $defaultValue;
        if (isset($_GET[$s])) {
            $value = $_GET[$s];
        }
        if (isset($_POST[$s])) {
            $value = $_POST[$s];
        }
        return $value;
    }

}

/*
  class Debug {

  var $mode;
  var $pre;
  var $level = 1;

  function out($s, $HTML = false, $insertNewlines = true, $pre = false) {
  if (isset($this) && !$pre) {
  $pre = $this->pre;
  }
  if (isset($this) && !$HTML) {
  $HTML = $this->mode;
  }

  if ($pre) {
  echo "<pre>";
  }
  if ($HTML) {
  echo '<div class="debug">';
  print_r($s);
  if ($insertNewlines) {
  echo '<br/>';
  } else {
  print_r($s);
  }
  if ($insertNewlines) {
  echo "\n";
  }
  echo '</div>';
  }
  }

  function testCube() {
  $c = new Cube();
  $c->performAlg('RULBRLUBRURLBU');
  echo $c->toImageCubeStickers();
  }
  function stop($s, $HTML = false, $insertNewlines = true, $pre = false)
  {
  Debug::out($s, $HTML, $insertNewlines, $pre);
  die();
  }


  }

  }
 */

class Point {

    var $x;
    var $y;
    var $z;

    function Point($x = 0.0, $y = 0.0, $z = 0.0) {
        $this->x = (double) $x;
        $this->y = (double) $y;
        $this->z = (double) $z;
    }

    function rotateY($angle) {
        return $this->x * cos($angle) - $this->y * sin($angle);
    }

    function rotateX($angle) {
        return $this->x * sin($angle) + $this->y * cos($angle);
    }

    function product($p) {
        $result = 0.0;
        $result += $this->x * $p->x;
        $result += $this->y * $p->y;
        $result += $this->z * $p->z;
        return $result;
    }

}

class Vector {

    var $p1; // starting point
    var $p2; // end point

    function Vector($p, $q) {
        $this->p1 = $p;
        $this->p2 = $q;
    }

    function rotateXY($angleX, $angleY) {
        $r = new Point; // rotated point
        // rotate 2D point YZ
        $p = new Point($this->p2->y, $this->p2->z, 0.0);
        $r->y = $p->rotateY($angleX); // y over x
        $r->z = $p->rotateX($angleX); // z over x
        // rotate 2D point XZ
        $p = new Point($this->p2->x, $r->z, 0.0);
        $r->x = $p->rotateY($angleY); // x over y
        $r->z = $p->rotateX($angleY); // z over y
        return $r->product($this->p1);
    }

    // project 3D coordinate to 2D
    function project2D($angleX, $angleY, $mirror) {
        $x = $this->p1->x;
        $y = $this->p1->y;
        $z = $this->p1->z;
        if ($mirror == 2) {
            $x = $this->p1->z;
            $z = $this->p1->x;
        }
        if ($mirror == 0) {
            $y = $this->p1->z;
            $z = -$this->p1->y;
        }
        $p = new Point($x, $y, $z);
        $q = new Point($this->p2->x, $this->p2->y, 0.0);
        $v = new Vector($p, $q);
        $nom = $v->rotateXY($angleX, $angleY);
        $q = new Point(0.0, 0.0, -1.0);
        $v = new Vector($p, $q);
        $den = 1.0 - 0.3 * $v->rotateXY($angleX, $angleY);
        return $nom / $den;
    }

}

// transpose 2D points into visible frame
// of the image output
class Screen {

    // the constants 0.58 and 0.52 are x,y transpositions
    function Screen($scale = 0.58, $posx = 0.52, $posy = 0.46) {
        $this->scale = $scale;
        $this->posx = $posx;
        $this->posy = $posy;
    }

    function getX($x, $m) {
        return ($m * $x * $this->scale + $this->posx);
    }

    function getY($y, $m) {
        return ($m * $y * $this->scale + $this->posy);
    }

}

class Graphics {

    var $mirrorX;
    var $mirrorY;
    var $image;
    var $scale;
    var $width;
    var $border;

    // convert an array of Point objects
    // into a list of x,y coordinates
    // e.g. array(x1,y1,x2,y2,x3,y3);
    function polygon($points, $is3D = false) {
        $out = array();
        foreach ($points as $p) {
            $out[] = $p->x;
            $out[] = $p->y;
            if ($is3D)
                $out[] = $p->z;
        }
        return $out;
    }

    function drawTile($points, $angleX, $angleY, $plane, $color) {
        foreach ($points as $p) {
            // find x
            $px = new Point(1, 0, 0); // to project to X
            $v = new Vector($p, $px);
            $x = $v->project2D($angleX, $angleY, $plane);
            // find y
            $py = new Point(0, 1, 0); // to project to Y
            $v = new Vector($p, $py);
            $y = $v->project2D($angleX, $angleY, $plane);
            // convert to screen coord
            $screen = new Screen;
            $x = $screen->getX($x, $this->mirrorX);
            $y = $screen->getY($y, $this->mirrorY);
            // scale
            $x *= $this->scale;
            $y *= $this->scale;
            $polyPoints[] = new Point($x, $y, 0.0);
        }
        $poly = $this->polygon($polyPoints);
        $numPoints = (int) (count($poly) / 2);
        // draw the tile
        imageFilledPolygon($this->image, $poly, $numPoints, $color);
    }

    /*
      $p zero point of square (left top)
      $plane - 0=U(z), 1=F(x), 2=R(y)
      $c color to paint the square
     */

    function square($p, $plane, $color) {
        $points = array();
        $b = $this->border; // - 0.5;
        $w = $this->width;
        $left = $p->x + $b - 0.5;
        $top = $p->y + $b - 0.5;
        $right = $p->x + $w - $b - 0.5;
        $bottom = $p->y + $w - $b - 0.5;

        $points[] = new Point($left, $top, $p->z);
        $points[] = new Point($right, $top, $p->z);
        $points[] = new Point($right, $bottom, $p->z);
        $points[] = new Point($left, $bottom, $p->z);

        $viewPointX = -0.5;
        $viewPointY = 0.6;
        $this->drawTile($points, $viewPointX, $viewPointY, $plane, $color);
    }

}

class iCube {

    function create($size, $format, $background) {
        // create image and make transparent if necessary
        $dim = min(5 * $size, 500); // dimension
        $im = imageCreateTrueColor($dim, $dim);
        if (strtolower($format) == 'png' && $background == 0xFFFFFF) {
            imageAlphaBlending($im, false);
            $color = imageColorAllocateAlpha($im, 0, 0, 0, 127);
        } else {
            $color = $background;
        }

        imageFilledRectangle($im, 0, 0, $dim - 1, $dim - 1, $color);
        return $im;
    }

    function smooth($im, $size, $format, $background) {
        imageAntiAlias($im, true);
        $dim = min(5 * $size, 500); // dimension
        $im2 = imageCreateTrueColor($size, $size);
        if (strtolower($format) == 'png') {
            imageAlphaBlending($im2, false);
            $color = imageColorAllocateAlpha($im2, 0, 0, 0, 127);
        } else
            $color = $background;
        // smoothing the image by resizing in steps
        imageFilledRectangle($im2, 0, 0, $size - 1, $size - 1, $color);
        imageCopyResampled($im2, $im, 0, 0, 0, 0, $size, $size, $dim, $dim);
        imageDestroy($im);
        return $im2;
    }

    function draw($image, $format, $quality = 90) {
        global $constants;
        switch (strtolower($format)) {
            case 'gif':
                header('Content-type: image/gif');
                imagegif($image);
                break;
            case 'jpg':
            case 'jpeg':
                header('Content-type: image/jpeg');
                imageInterlace($image, true);
                imagejpeg($image, NULL, $quality);
                break;
            case 'png':
                header('Content-type: image/png');
                imageAlphaBlending($image, false);
                imageSaveAlpha($image, true);
                imagepng($image);
                break;
        }
    }

    function run() {
        global $constants;

        $colors = $constants->colors;
        $p = new Page;
        /* get parameters */
        $format = $p->get('format', 'png');
        $size = $p->get('size');
        $dim = min($constants->smoothing * $size, $constants->smoothing * 100); // dimension
        $fl = $p->get('fl', $p->get('stickers')); // facelets
        $background = hexdec($p->get('bgcolor', 0)); // background
        if ($background == 0)
            $background = 0xFFFFFF;
        // mirrors X and Y
        $mirror = $p->get('m', '');
        $mx = $my = 1;
        if ($mirror == 'x')
            $mx = -1;
        if ($mirror == 'y')
            $my = -1;
        if ($mirror == 'xy')
            $mx = $my = -1;

        $im = $this->create($size, $format, $background);

        $g = new Graphics;
        $g->width = 1;
        $g->border = 0;
        $g->mirrorX = $mx;
        $g->mirrorY = $my;
        $g->image = $im;
        $g->scale = $dim;

        $faces = new stdClass();
        list($faces->up, $faces->front, $faces->right) = range(0, 2);

        // solid black frameworks of U, F and R faces
        // colors are slightly different because of shadow
        $p = new Point(0.0, 0.0, -0.5);

        $g->square($p, $faces->up, $colors['black']);
        $g->square($p, $faces->front, $colors['darkGray']);
        $p->z = 0.5;
        $g->square($p, $faces->right, $colors['veryDarkGray']);

        // create 27 colored facelets on U,F,R
        $g->width = 0.333;
        $g->border = 0.028;
        foreach (array($faces->up, $faces->front, $faces->right) as $face) // face
            foreach (range(0, 2) as $row) // row
                foreach (range(0, 2) as $column) { // column
                    $c = substr($fl, $face * 9 + $row * 3 + $column, 1);
                    $color = $colors[$c];
                    $g->plane = $face;
                    $x = (double) ($column / 3.0); // 001001001 001001001 001001001
                    $y = (double) ($row / 3.0); // 000000111 000000111 000000111
                    $z = 0.51;
                    if ($face != $faces->right)
                        $z = -$z;
                    $p = new Point($x, $y, $z);
                    $g->square($p, $face, $color);
                }
        $im2 = $this->smooth($im, $size, $format, $background);
        $this->draw($im2, $format, 90);
    }

}

$icube = new iCube;
$icube->run();
?>